
#pragma warning(disable:4312)
#pragma warning(disable:4313)
#pragma warning(disable:4996)

#include "stdafx.h"
#include "ATCodeMgr.h"
#include "HookPoint.h"
#include "TransCommand.h"
#include "CharacterMapper.h"
#include "OptionMgr.h"

#include "Debug.h"

int CHookPoint::m_nKernelVer = 0;

bool CHookPoint::IsWinVistaAndAbove()
{
	/*
		OS Version
		Windows 2000	5.0
		Windows XP		5.1
		Windows 2003	5.2

		Windows Vista	6.0	: ASLR (Address Space Layout Randomization) 
		Windows 2008	6.0
		Windows	2008 R2	6.1
		Windows 7		6.1
	*/

	if (m_nKernelVer) return (m_nKernelVer > 5);

	OSVERSIONINFO osVer = {0, };

	osVer.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);

	if (!GetVersionEx(&osVer))
	{
		NOTIFY_DEBUG_MESSAGE(_T("GetVersionEx error: %d\n"), GetLastError());
		return false;
	}

	NOTIFY_DEBUG_MESSAGE(_T("IsWinVistaAndAbove: WinVer %d.%d.%d, Platform(%d) %s\n"),
		osVer.dwMajorVersion, osVer.dwMinorVersion, osVer.dwBuildNumber, osVer.dwPlatformId, osVer.szCSDVersion);

	CHookPoint::m_nKernelVer = osVer.dwMajorVersion;
	return (m_nKernelVer > 5);
}

CHookPoint::CHookPoint(void)
: m_hModule(NULL), m_pCodePoint(0)
{
}

CHookPoint::~CHookPoint(void)
{
	//  ɵ  
	DeleteAllTransCmd();
	
	// Unhook Լ غ
	PROC_UnhookCodePoint UnhookCodePoint = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnUnhookCodePoint;
	if(UnhookCodePoint)
	{
		// Unhook
		UnhookCodePoint( (LPVOID)GetHookAddress() );
	}
}

CHookPoint* CHookPoint::CreateInstance(CString strAddr)
{
	CHookPoint* pInst = new CHookPoint();

	try
	{
		int nIdx = strAddr.ReverseFind(_T('!'));
		
		if(nIdx>=0)
		{
			pInst->m_strModuleName = strAddr.Left(nIdx);

			pInst->m_hModule = GetModuleHandle(pInst->m_strModuleName);
			if(NULL == pInst->m_hModule) throw -4;
			
			_stscanf(strAddr.Mid(nIdx+1), _T("%x"), &pInst->m_pCodePoint);
		}
		else
		{
			if (CHookPoint::IsWinVistaAndAbove())
			{
				TCHAR szExePath[1024];

				GetModuleFileName(NULL, szExePath, 1024);

				for (int i=lstrlen(szExePath); i>=0; i--)
				{
					if (szExePath[i] == _T('\\'))
					{
						pInst->m_strModuleName = szExePath+i+1;
						break;
					}
				}

				if (pInst->m_strModuleName.IsEmpty())
				{
					pInst->m_hModule = NULL;
					_stscanf(strAddr.Mid(nIdx+1), _T("%x"), &pInst->m_pCodePoint);
				}
				else
				{
					UINT_PTR pCodePoint; 
					_stscanf(strAddr.Mid(nIdx+1), _T("%x"), &pCodePoint);

					pInst->m_hModule = GetModuleHandle(NULL);
					pInst->m_pCodePoint = pCodePoint - 0x400000;
				}
				NOTIFY_DEBUG_MESSAGE(_T("CreateInstance: module %s, hModule %p, Codepoint %p\n"),
					pInst->m_strModuleName, pInst->m_hModule, pInst->m_pCodePoint);
			}
			else
			{
				pInst->m_hModule = NULL;
				_stscanf(strAddr.Mid(nIdx+1), _T("%x"), &pInst->m_pCodePoint);
			}
		}

		if(NULL == pInst->m_pCodePoint) throw -1;

		// ŷ Լ غ
		PROC_HookCodePoint HookCodePoint = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnHookCodePoint;
		if(HookCodePoint == NULL) throw -2;

		// ŷ
		BOOL bHookRes = HookCodePoint((LPVOID)pInst->GetHookAddress(), PointCallback);
		if(bHookRes == FALSE) throw -3;
		
		TRACE("[aral1]  %p Hooked \n", pInst->GetHookAddress());
	}
	catch(int nErrCode)
	{
		nErrCode = nErrCode;
		delete pInst;
		pInst = NULL;
	}

	return pInst;
}

//////////////////////////////////////////////////////////////////////////
//
//  νϽ ŷ ּҸ ȯմϴ.
//
//////////////////////////////////////////////////////////////////////////
UINT_PTR CHookPoint::GetHookAddress()
{
	return ( (UINT_PTR)m_hModule + m_pCodePoint );
}

//////////////////////////////////////////////////////////////////////////
//
//  νϽ ŷ ּҸ ȭ ڿ · ȯմϴ.
//
//////////////////////////////////////////////////////////////////////////
CString CHookPoint::GetHookAddressString()
{
	CString strRetVal;

	if(NULL == m_hModule)
	{
		strRetVal.Format(_T("0x%p"), m_pCodePoint);
	}
	else
	{
		strRetVal.Format(_T("%s!0x%p"), (LPCTSTR)m_strModuleName, m_pCodePoint);
	}
	
	return strRetVal;
}


//////////////////////////////////////////////////////////////////////////
//
// ο   մϴ.
//
//////////////////////////////////////////////////////////////////////////
CTransCommand* CHookPoint::AddTransCmd(COptionNode *pNode)
{

	//  Ÿ
	COptionNode* pDistNode = pNode->GetChild(0);

	CString strArgScript = pDistNode->GetValue();
	strArgScript.Remove(_T(' '));
	CTransCommand* pCmd = FindTransCmd(strArgScript);
	
	if(pCmd == NULL)
	{
		pCmd = CTransCommand::CreateTransCommand(strArgScript, pNode);

		m_vectorTransCmd.push_back(pCmd);
	}

	return pCmd;
}

//////////////////////////////////////////////////////////////////////////
//
//   ãϴ.
//
//////////////////////////////////////////////////////////////////////////
CTransCommand* CHookPoint::FindTransCmd(CString strArgScript)
{
	CTransCommand* pCmd = NULL;

	strArgScript.Remove(_T(' '));
	for(vector<CTransCommand*>::iterator iter = m_vectorTransCmd.begin();
		iter != m_vectorTransCmd.end();
		iter++)
	{
		if((*iter)->GetArgScript().CompareNoCase(strArgScript) == 0)
		{
			pCmd = (*iter);
			break;
		}
	}

	return pCmd;
}


//////////////////////////////////////////////////////////////////////////
//
//     մϴ.
//
//////////////////////////////////////////////////////////////////////////
int CHookPoint::GetTransCmdCount()
{
	return (int)m_vectorTransCmd.size();
}


//////////////////////////////////////////////////////////////////////////
//
// Ư°   մϴ.
//
//////////////////////////////////////////////////////////////////////////
CTransCommand* CHookPoint::GetTransCmd(int nIdx)
{
	CTransCommand* pCmd = NULL;
	
	if((size_t)nIdx < m_vectorTransCmd.size())
	{
		pCmd = m_vectorTransCmd[nIdx];
	}

	return pCmd;
}


//////////////////////////////////////////////////////////////////////////
//
//   մϴ.
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::DeleteTransCmd(int nIdx)
{
	if((size_t)nIdx < m_vectorTransCmd.size())
	{
		CTransCommand* pCmd = m_vectorTransCmd[nIdx];
		delete pCmd;
		m_vectorTransCmd.erase(m_vectorTransCmd.begin()+nIdx);
	}	
}

//////////////////////////////////////////////////////////////////////////
//
//    մϴ.
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::DeleteAllTransCmd()
{
	for(vector<CTransCommand*>::iterator iter = m_vectorTransCmd.begin();
		iter != m_vectorTransCmd.end();
		iter++)
	{
		CTransCommand* pCmd = (*iter);
		delete pCmd;
	}

	m_vectorTransCmd.clear();
}



//////////////////////////////////////////////////////////////////////////
//
// Ư ŷ ݹ Լ (static)
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::PointCallback(LPVOID pHookedPoint, PREGISTER_ENTRY pRegisters)
{
	
	CATCodeMgr* pATCodeMgr = CATCodeMgr::GetInstance();
	if(NULL == pATCodeMgr) return;

	bool bRestore=false;
	list<CHookPoint*>::iterator iter;
	CHookPoint* pPoint;

	// Ÿʿ ŷ ϱ
	for(iter = pATCodeMgr->m_listHookPoint.begin(); iter != pATCodeMgr->m_listHookPoint.end(); iter++)
	{
		pPoint = (*iter);

		if(pPoint->GetHookAddress() == (UINT_PTR)pHookedPoint)
		{
			if (pPoint->GetTransCmdCount() == 0)
			{
				bRestore=true;
				break;
			}

			//   
			pPoint->ExecuteTransCmds(pRegisters);
			break;
		}
	}

	if (bRestore) //    ŷڵ
	{
		//   ޸ 
		for(iter = pATCodeMgr->m_listHookPoint.begin(); iter != pATCodeMgr->m_listHookPoint.end(); iter++)
		{
			pPoint = (*iter);

			int cnt = pPoint->GetTransCmdCount();
			for(int i=0; i<cnt; i++)
			{
				CTransCommand *pCmd=pPoint->GetTransCmd(i);
				pCmd->RestoreBackup();
			}

		}
	}


}

//////////////////////////////////////////////////////////////////////////
//
//  ۾  (ƼƮ / ڵ )
//
//////////////////////////////////////////////////////////////////////////
void CHookPoint::ExecuteTransCmds(PREGISTER_ENTRY pRegisters)
{
	NOTIFY_DEBUG_MESSAGE(_T("ExecuteTransCmds: called, CodePoint=%p\n"), (UINT_PTR)m_hModule + m_pCodePoint );

	int cnt = GetTransCmdCount();

	m_parser.SetRegisterValues(pRegisters);

	for(int i=0; i<cnt; i++)
	{
		CTransCommand* pCmd = GetTransCmd(i);		
		LPVOID pArgText = NULL;

		NOTIFY_DEBUG_MESSAGE(_T("ExecuteTransCmds: ArgScript=%s\n"),pCmd->GetArgScript());
		
		try
		{
			BOOL bTrans = FALSE;
			CString strClipboardText = _T("");

			// ؽƮ ִ ġ 
			pArgText=pCmd->GetTextPoint(&m_parser);

			if (pArgText == NULL) continue;	// ؽƮ ġ ߸Ǿų ؾ  Ÿ


			//  ؽƮ Ȯ
			if (!pCmd->IsValidTextPoint(pArgText)) throw -3; // _T("߸ ڿ Դϴ.");

			// ߺ   Ȯ
			BOOL bIsDuplicated = pCmd->IsDuplicateText(pArgText);
			if (!bIsDuplicated) 
			{
				// ڵ ̶
				if(pCmd->GetUnicode())
				{
					LPWSTR wszText = (LPWSTR) pArgText;

					// ֱ Ϻ 
					ZeroMemory(pCmd->m_pOrigTextBuf, sizeof(pCmd->m_pOrigTextBuf));
					wcscpy((LPWSTR)pCmd->m_pOrigTextBuf, wszText);

					// ƼƮ ȯ
					char szAnsiJpn[MAX_TEXT_LENGTH*2];
					char szAnsiKor[MAX_TEXT_LENGTH*2];

					MyWideCharToMultiByte(932, 0, wszText, -1, szAnsiJpn, MAX_TEXT_LENGTH*2, NULL, NULL);

					// Ϻ  Ŭ  ˻
					if( pCmd->GetClipJpn() )
					{
#ifdef UNICODE
						strClipboardText += wszText;
#else
						strClipboardText += szAnsiJpn;
#endif
					}

					// ⿡ ־
					PROC_TranslateText pfnTransJ2K = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnTranslateText;
					if( pfnTransJ2K == NULL ) throw -2; //_T("AT ̳ Լ ã  ϴ.");

					bTrans = pfnTransJ2K(szAnsiJpn, szAnsiKor, MAX_TEXT_LENGTH*2);			
					if( bTrans )
					{
						// Ÿ ִ  
						pCmd->RestoreBackup();

#ifdef UNICODE
						wchar_t wszTmpKor[MAX_TEXT_LENGTH];
						MyMultiByteToWideChar(949, 0, szAnsiKor, -1, wszTmpKor, MAX_TEXT_LENGTH);
						CString strKorean = wszTmpKor;
#else
						CString strKorean = szAnsiKor;
#endif

						// ѱ  Ŭ  ˻
						if( pCmd->GetClipKor() )
						{
							strClipboardText += strKorean;
						}

						//  
						//if(CATCodeMgr::GetInstance()->m_bPtrCheat == FALSE && CATCodeMgr::GetInstance()->m_bRemoveSpace)
						if( pCmd->GetRemoveSpace() )
						{
							strKorean.Replace(_T(" "), _T(""));
						}

						// ֱ ѱ 
						ZeroMemory(pCmd->m_pTransTextBuf, sizeof(pCmd->m_pTransTextBuf));
#ifdef UNICODE
						wcscpy((LPWSTR)pCmd->m_pTransTextBuf, (LPCWSTR)strKorean);
#else
						MyMultiByteToWideChar(949, 0, (LPCSTR)strKorean, -1, (LPWSTR)pCmd->m_pTransTextBuf, MAX_TEXT_LENGTH);
#endif
					}
					else // bTrans == FALSE
					{
						NOTIFY_DEBUG_MESSAGE(_T("ExecuteTransCmds: Translate failed\n"));
						continue;
					}

				}		
				// ƼƮ ̶
				else
				{
					LPSTR szText = (LPSTR) pArgText;

					// ֱ Ϻ 
					ZeroMemory(pCmd->m_pOrigTextBuf, sizeof(pCmd->m_pOrigTextBuf));
					strcpy((LPSTR)pCmd->m_pOrigTextBuf, szText);


					// Ϻ  Ŭ  ˻
					if( pCmd->GetClipJpn() )
					{
#ifdef UNICODE
						wchar_t wszTmpJpn[MAX_TEXT_LENGTH];
						MyMultiByteToWideChar(932, 0, szText, -1, wszTmpJpn, MAX_TEXT_LENGTH);
						strClipboardText += wszTmpJpn;
#else
						strClipboardText += szText;
#endif
					}

					// ⿡ ־
					PROC_TranslateText pfnTransJ2K = CATCodeMgr::GetInstance()->m_sContainerFunc.pfnTranslateText;
					if( pfnTransJ2K == NULL )
					{
						throw -2; //"AT ̳ Լ ã  ϴ.";
					}
					
					char szAnsiKor[MAX_TEXT_LENGTH*2];

					bTrans = pfnTransJ2K(szText, szAnsiKor /*(char*)pCmd->m_pTransTextBuf*/, MAX_TEXT_LENGTH*2);	
					if( bTrans )
					{
						// Ÿ ִ  
						pCmd->RestoreBackup();

						strcpy((char*)pCmd->m_pTransTextBuf, szAnsiKor);

#ifdef UNICODE
						wchar_t wszTmpKor[MAX_TEXT_LENGTH];
						MyMultiByteToWideChar(949, 0, (LPCSTR)pCmd->m_pTransTextBuf, -1, wszTmpKor, MAX_TEXT_LENGTH);
						CString strKorean = wszTmpKor;
#else
						CString strKorean = (LPCSTR)pCmd->m_pTransTextBuf;
#endif

						// ѱ  Ŭ  ˻
						if( pCmd->GetClipKor() )
						{
							strClipboardText += strKorean;
						}

						//  
						if( pCmd->GetRemoveSpace() )
						{
							strKorean.Replace(_T(" "), _T(""));
							MyWideCharToMultiByte(949, 0, strKorean, -1, (LPSTR)pCmd->m_pTransTextBuf, MAX_TEXT_LENGTH*2, NULL, NULL);
							//ReduceSpaceA((LPSTR)pCmd->m_pTransTextBuf, (int)strlen(szText));
						}

						// 2Ʈ 籸
						if( pCmd->GetTwoByte() )
						{
							EnforceTwoBtye((LPSTR)pCmd->m_pTransTextBuf);
						}

						// ѱ ڵ (ƼƮ 츸)
						if( CATCodeMgr::GetInstance()->m_bEncodeKorean )
						{
							EncodeMultiBytes((LPSTR)pCmd->m_pTransTextBuf);
						}

					}
					else // bTrans == FALSE
					{
						NOTIFY_DEBUG_MESSAGE(_T("ExecuteTransCmds: Translate failed\n"));
						continue;
					}

				} // if(pCmd->GetUnicode()) ...
			} // if (!pCmd->IsDuplicateText(pArgText)) ...

			// NOTE
			// Ϻ иŰ pCmd->m_pOrigTextBuf   Ÿ ִ 
			// pCmd->m_pTransTextBuf   ͸ ִ  (Duplicate   passϴ  )
			//  CTransCommand      Ѿ.
			//  Ŭ и   ĸ ó и ο  ߰  
			//  ϱ  ε ܼ ڿ 縦  ޼ҵ 鼭 ߰ ʿ䰡
			//    .

			//  pCmd->m_pOrigTextBuf  , pCmd->m_pTransTextBuf    

			//  
			pCmd->ChangeLength(pArgText, &m_parser);

			//  ڿ  α׷ ݿ
			if (!pCmd->ApplyTranslatedText(pArgText, pRegisters, &m_parser, bIsDuplicated))
				throw -5;

			pCmd->m_pPrevArgText = pArgText;

			// Ŭ 
			if(!strClipboardText.IsEmpty())
			{
				CATCodeMgr::GetInstance()->SetClipboardText(strClipboardText);
			}

		}
		catch (int nErrCode)
		{
			nErrCode = nErrCode;
			TRACE(_T("ExecuteTransCmds exception code : %d \n"), nErrCode);
			NOTIFY_DEBUG_MESSAGE(_T("ExecuteTransCmds exception code : %d \n"), nErrCode);
		}

	} // end of for

}

BOOL CHookPoint::EnforceTwoBtye(LPSTR szText)
{
	if(NULL == szText) return FALSE;

	char szKorean[MAX_TEXT_LENGTH*2];
	strcpy(szKorean, szText);

	int len = (int)strlen(szKorean);
	int i = 0;
	int j = 0;
	while( i<len )
	{
		if( 0x80 <= (BYTE)szKorean[i] )
		{
			szText[j] = szKorean[i];
			szText[j+1] = szKorean[i+1];

			i+=2;
		}
		else
		{
			
			//WORD wChar = CCharacterMapper::Ascii2ShiftJIS(szKorean[i]);
			WORD wChar = CCharacterMapper::Ascii2KS5601(szKorean[i]);
			if(' ' == szKorean[i]) wChar = 0x8140;
			
			if(wChar)
			{
				szText[j] = (char)HIBYTE(wChar);
				szText[j+1] = (char)LOBYTE(wChar);
			}
			else
			{
				szText[j] = szKorean[i];
				if( 0x80 <= (BYTE)szKorean[i+1] )
				{
					szText[j+1] = ' ';
				}
				else
				{
					++i;
					szText[j+1] = szKorean[i];
				}
			}

			i++;
		}

		j+=2;
	}

	szText[j] = '\0';

	return TRUE;
}

BOOL CHookPoint::EncodeMultiBytes( LPSTR szNewText )
{

	// ƼƮ ڵ
	int len = (int)strlen(szNewText);
	int i = 0;
	while( i<len )
	{
		if( 0x80 <= (BYTE)szNewText[i] )
		{
			char tmpbuf[3];
			tmpbuf[0] = szNewText[i];
			tmpbuf[1] = szNewText[i+1];
			tmpbuf[2] = '\0';

			CCharacterMapper::EncodeK2J(tmpbuf, &szNewText[i]);

			i++;
		}

		i++;
	}
	
	szNewText[i] = '\0';

	return TRUE;
}

BOOL CHookPoint::ReduceSpaceA( LPSTR szText, int nSizeTo )
{
	if(NULL == szText) return FALSE;

	char szKorean[MAX_TEXT_LENGTH*2];
	strcpy(szKorean, szText);

	int len = (int)strlen(szKorean);
	int nRemoveCnt = len - nSizeTo;
	int i = 0;
	int j = 0;
	while( i<len )
	{
		if( 0x80 <= (BYTE)szKorean[i])
		{
			szText[j++] = szKorean[i++];
			szText[j++] = szKorean[i++];
		}
		else
		{
			if(' ' != szKorean[i]  || nRemoveCnt <= 0)
			{
				szText[j++] = szKorean[i];
			}
			else
			{
				nRemoveCnt--;
			}

			i++;
		}
	}

	szText[j] = '\0';

	return TRUE;

}
