// PageHook.cpp : implementation file
//

#pragma warning(disable:4996)
#pragma comment (lib, "psapi.lib")

#include "stdafx.h"
#include "ATCode.h"
#include "PageHook.h"
#include "OptionMgr.h"
#include "OptionDlg.h"
#include "MemoryDlg.h"
#include "ModuleInfoDlg.h"


// CPageHook dialog

IMPLEMENT_DYNAMIC(CPageHook, CDialog)

CPageHook::CPageHook(CWnd* pParent /*=NULL*/)
	: CDialog(CPageHook::IDD, pParent), m_pHookNode(NULL)
	, m_iTransMethod(0)
{

}

CPageHook::~CPageHook()
{
}

void CPageHook::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_COMBO_TRANS_ARGS, m_comboTransArgs);

	DDX_Control(pDX, IDC_CHK_UNICODE, m_chkUnicode);
	DDX_Control(pDX, IDC_CHK_SAFE, m_chkSafe);
	DDX_Control(pDX, IDC_CHK_ALLSAMETEXT, m_chkAllSameText);
	DDX_Control(pDX, IDC_CHK_CLIP_JPN, m_chkClipJpn);
	DDX_Control(pDX, IDC_CHK_CLIP_KOR, m_chkClipKor);
	DDX_Control(pDX, IDC_CHK_REMOVE_SPACE, m_chkRemoveSpace);
	DDX_Control(pDX, IDC_CHK_TWOBYTE, m_chkTwoByte);

	DDX_Control(pDX, IDC_BTN_ARG_DEL, m_btnDelArg);
	DDX_Radio(pDX, IDC_RADIO_NOP, m_iTransMethod);
	DDX_Control(pDX, IDC_CHK_IGNORE, m_chkIgnore);
	DDX_Control(pDX, IDC_CHK_MATCH, m_chkMatch);
	DDX_Control(pDX, IDC_CHK_USELEN, m_chkUseLen);
	DDX_Control(pDX, IDC_EDIT_LENPOS, m_editLenPos);
}


BEGIN_MESSAGE_MAP(CPageHook, CDialog)
	ON_CBN_SELCHANGE(IDC_COMBO_TRANS_ARGS, &CPageHook::OnCbnSelchangeComboTransArgs)
	ON_BN_CLICKED(IDC_BTN_ARG_ADD, &CPageHook::OnBnClickedBtnArgAdd)
	ON_BN_CLICKED(IDC_BTN_ARG_DEL, &CPageHook::OnBnClickedBtnArgDel)

	ON_BN_CLICKED(IDC_BTN_DEL_HOOK, &CPageHook::OnBnClickedBtnDelHook)

	ON_BN_CLICKED(IDC_RADIO_NOP, &CPageHook::OnBnClickedRadio)
	ON_BN_CLICKED(IDC_RADIO_PTRCHANGE, &CPageHook::OnBnClickedRadio)
	ON_BN_CLICKED(IDC_RADIO_OVERWRITE, &CPageHook::OnBnClickedRadio)
	ON_BN_CLICKED(IDC_RADIO_SOW, &CPageHook::OnBnClickedRadio)
	ON_BN_CLICKED(IDC_RADIO_SMSTR, &CPageHook::OnBnClickedRadio)

	ON_BN_CLICKED(IDC_CHK_UNICODE, &CPageHook::OnBnClickedChkUnicode)
	ON_BN_CLICKED(IDC_CHK_ALLSAMETEXT, &CPageHook::OnBnClickedChkAllsametext)
	ON_BN_CLICKED(IDC_CHK_CLIP_JPN, &CPageHook::OnBnClickedChkClipJpn)
	ON_BN_CLICKED(IDC_CHK_CLIP_KOR, &CPageHook::OnBnClickedChkClipKor)
	ON_BN_CLICKED(IDC_CHK_REMOVE_SPACE, &CPageHook::OnBnClickedChkRemoveSpace)
	ON_BN_CLICKED(IDC_CHK_TWOBYTE, &CPageHook::OnBnClickedChkTwobyte)
	ON_BN_CLICKED(IDC_CHK_SAFE, &CPageHook::OnBnClickedChkSafe)
	ON_BN_CLICKED(IDC_CHK_IGNORE, &CPageHook::OnBnClickedChkIgnore)
	ON_BN_CLICKED(IDC_CHK_MATCH, &CPageHook::OnBnClickedChkMatch)
	ON_BN_CLICKED(IDC_CHK_USELEN, &CPageHook::OnBnClickedChkUselen)
	ON_EN_CHANGE(IDC_EDIT_LENPOS, &CPageHook::OnEnChangeEditLenpos)
END_MESSAGE_MAP()


//////////////////////////////////////////////////////////////////////////
//
// ŷ  UI 
//
//////////////////////////////////////////////////////////////////////////
BOOL CPageHook::InitFromHookNode( COptionNode* pHookNode )
{
	BOOL bRetVal = FALSE;

	m_pHookNode = NULL;

	m_comboTransArgs.Clear();
	m_comboTransArgs.ResetContent();
	m_comboTransArgs.EnableWindow(FALSE);

	this->GetDlgItem(IDC_RADIO_NOP)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_RADIO_PTRCHANGE)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_RADIO_OVERWRITE)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_RADIO_SOW)->EnableWindow(FALSE);
	this->GetDlgItem(IDC_RADIO_SMSTR)->EnableWindow(FALSE);

	m_chkUnicode.EnableWindow(FALSE);
	m_chkAllSameText.EnableWindow(FALSE);
	m_chkClipKor.EnableWindow(FALSE);
	m_chkClipJpn.EnableWindow(FALSE);
	m_chkRemoveSpace.EnableWindow(FALSE);
	m_chkSafe.EnableWindow(FALSE);
	m_chkTwoByte.EnableWindow(FALSE);
	m_chkIgnore.EnableWindow(FALSE);
	m_chkMatch.EnableWindow(FALSE);
	m_chkUseLen.EnableWindow(FALSE);
	m_editLenPos.EnableWindow(FALSE);

	m_btnDelArg.EnableWindow(FALSE);

	ClearCtrlValues();

	try
	{
		if(NULL==pHookNode || pHookNode->GetValue().CompareNoCase(_T("HOOK"))) throw -1;

		//  ּҰ   
		COptionNode* pAddrNode = pHookNode->GetChild(0);
		if(pAddrNode==NULL) throw -2;

		CString strAddr = pAddrNode->GetValue();


		//  ּҿ  ŷ ɵ 
		int cnt2 = pHookNode->GetChildCount();
		for(int j=1; j<cnt2; j++)
		{
			COptionNode* pCmdNode = pHookNode->GetChild(j);
			CString strCmdValue = pCmdNode->GetValue();

			//  
			if(strCmdValue.CompareNoCase(_T("TRANS"))==0)
			{
				//  Ÿ
				COptionNode* pDistNode = pCmdNode->GetChild(0);
				if(pDistNode==NULL) throw -4;

				CString strStorage = pDistNode->GetValue().MakeUpper();
				int nComboIdx = m_comboTransArgs.AddString(strStorage);
				m_comboTransArgs.SetItemData(nComboIdx, (DWORD_PTR)pCmdNode);

			}

		}

		// ޺ڽ ϳ  ȰȭŴ
		if( m_comboTransArgs.GetCount() > 0 )
		{
			m_comboTransArgs.SetCurSel(0);
			m_comboTransArgs.EnableWindow(TRUE);

			this->GetDlgItem(IDC_RADIO_NOP)->EnableWindow(TRUE);
			this->GetDlgItem(IDC_RADIO_PTRCHANGE)->EnableWindow(TRUE);
			this->GetDlgItem(IDC_RADIO_OVERWRITE)->EnableWindow(TRUE);
			this->GetDlgItem(IDC_RADIO_SOW)->EnableWindow(TRUE);
			this->GetDlgItem(IDC_RADIO_SMSTR)->EnableWindow(TRUE);

			m_chkUnicode.EnableWindow(TRUE);
			m_chkAllSameText.EnableWindow(TRUE);
			m_chkClipKor.EnableWindow(TRUE);
			m_chkClipJpn.EnableWindow(TRUE);
			m_chkRemoveSpace.EnableWindow(TRUE);
			m_chkSafe.EnableWindow(TRUE);
			m_chkTwoByte.EnableWindow(TRUE);
			m_chkUseLen.EnableWindow(TRUE);

			m_btnDelArg.EnableWindow(TRUE);
			OnCbnSelchangeComboTransArgs();
		}

		UpdateData(FALSE);
		m_pHookNode = pHookNode;
		bRetVal = TRUE;
	}
	catch (int nErr)
	{
		nErr = nErr;
	}

	return bRetVal;
}



//////////////////////////////////////////////////////////////////////////
//
// UI ʱȭ
//
//////////////////////////////////////////////////////////////////////////
void CPageHook::ClearCtrlValues()
{
	m_iTransMethod = 0;

	m_chkUnicode.SetCheck(0);
	m_chkAllSameText.SetCheck(0);
	m_chkClipJpn.SetCheck(0);
	m_chkClipKor.SetCheck(0);
	m_chkSafe.SetCheck(0);
	m_chkRemoveSpace.SetCheck(0);
	m_chkTwoByte.SetCheck(0);
	m_chkIgnore.SetCheck(0);
	m_chkMatch.SetCheck(0);
	m_chkUseLen.SetCheck(0);
	m_editLenPos.SetWindowText(_T(""));
	
	UpdateData(FALSE);

}
// CPageHook message handlers



//////////////////////////////////////////////////////////////////////////
//
//  ڰ ٲ 
//
//////////////////////////////////////////////////////////////////////////
void CPageHook::OnCbnSelchangeComboTransArgs()
{
	ClearCtrlValues();

	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{

		//  ɼǵ 
		int cnt3 = pTransCmdNode->GetChildCount();
		for(int k=1; k<cnt3; k++)
		{
			COptionNode* pNode3 = pTransCmdNode->GetChild(k);
			CString strTransOption = pNode3->GetValue().MakeUpper();

			if(strTransOption.IsEmpty())
			{
				continue;
			}

			// NOP ɼ (ƹ۾ )
			else if(strTransOption == _T("NOP"))
			{
				m_iTransMethod = 0;
				UpdateData(FALSE);
			}
			// PTRCHEAT ɼ ( ٲġ)
			else if(strTransOption == _T("PTRCHEAT"))
			{
				m_iTransMethod = 1;
				m_chkIgnore.SetCheck(0);
				m_chkIgnore.EnableWindow(FALSE);
				UpdateData(FALSE);
			}
			// OVERWRITE ɼ (޸ )
			else if(strTransOption == _T("OVERWRITE"))
			{
				m_iTransMethod = 2;
				m_chkIgnore.SetCheck(0);
				m_chkIgnore.EnableWindow(TRUE);
				if(pNode3->GetChild(_T("IGNORE")) != NULL)
				{
					m_chkIgnore.SetCheck(1);
				}
				UpdateData(FALSE);
			}
			// Script OverWrite ɼ (ũƮ )
			else if(strTransOption == _T("SOW"))
			{
				m_iTransMethod = 3;
				UpdateData(FALSE);
			}
			// SMart STRing ɼ (Ʈ ڿ)
			else if(strTransOption == _T("SMSTR"))
			{
				m_iTransMethod = 4;
				m_chkIgnore.SetCheck(0);
				m_chkIgnore.EnableWindow(TRUE);
				if(pNode3->GetChild(_T("IGNORE")) != NULL)
				{
					m_chkIgnore.SetCheck(1);
				}
				m_chkMatch.SetCheck(0);
				m_chkMatch.EnableWindow(TRUE);
				if(pNode3->GetChild(_T("MATCH")) != NULL)
				{
					m_chkMatch.SetCheck(1);
				}
				UpdateData(FALSE);
			}


			// ƼƮ / ڵ 
			else if(strTransOption == _T("ANSI"))
			{
				m_chkUnicode.SetCheck(0);
			}
			else if(strTransOption == _T("UNICODE"))
			{
				m_chkUnicode.SetCheck(1);
			}

			//  ġϴ ؽƮ 
			else if(strTransOption == _T("ALLSAMETEXT"))
			{
				m_chkAllSameText.SetCheck(1);
			}

			//  ؽƮ Ŭ
			else if(strTransOption == _T("CLIPKOR"))
			{
				m_chkClipKor.SetCheck(1);
			}

			//  ؽƮ Ŭ
			else if(strTransOption == _T("CLIPJPN"))
			{
				m_chkClipJpn.SetCheck(1);
			}

			//  ؽƮ    
			else if(strTransOption == _T("REMOVESPACE"))
			{
				m_chkRemoveSpace.SetCheck(1);
			}

			// Ϻ ȿ ˻
			else if(strTransOption == _T("SAFE"))
			{
				m_chkSafe.SetCheck(1);
			}

			// ݰ ڸ  ڷ
			else if(strTransOption == _T("TWOBYTE"))
			{
				m_chkTwoByte.SetCheck(1);
			}
			else if(strTransOption == _T("LEN"))
			{
				COptionNode *pNode4 = pNode3->GetChild(0);
				CString strLenPos = pNode4->GetValue().MakeUpper();

				if (!strLenPos.IsEmpty())
				{
					m_chkUseLen.SetCheck(1);
					m_editLenPos.EnableWindow(TRUE);
					m_editLenPos.SetWindowText(strLenPos);
				}
			}
		}
	}
}

void CPageHook::OnBnClickedRadio()
{	
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		//    
		pTransCmdNode->DeleteChild(_T("NOP"));
		pTransCmdNode->DeleteChild(_T("PTRCHEAT"));
		pTransCmdNode->DeleteChild(_T("OVERWRITE"));
		pTransCmdNode->DeleteChild(_T("SOW"));
		pTransCmdNode->DeleteChild(_T("SMSTR"));

		//    
		UpdateData(TRUE);
		LPCTSTR TRANS_METHOS[] = {
			_T("NOP"),
			_T("PTRCHEAT"),
			_T("OVERWRITE"),
			_T("SOW"),
			_T("SMSTR")
		};
		
		COptionNode* pNode = pTransCmdNode->CreateChild();
		pNode->SetValue(TRANS_METHOS[m_iTransMethod]);
		
		if(2 == m_iTransMethod)	// 2 (OVERWRITE)
		{
			m_chkIgnore.EnableWindow(TRUE);
			m_chkMatch.EnableWindow(FALSE);
			OnBnClickedChkIgnore();
		}
		else if(4 == m_iTransMethod) // 4(SMSTR)
		{
			m_chkIgnore.EnableWindow(TRUE);
			m_chkMatch.EnableWindow(TRUE);
			OnBnClickedChkIgnore();
			OnBnClickedChkMatch();
		}
		else // 0 (NOP), 1 (PTRCHEAT), 3 (SOW)
		{
			m_chkIgnore.EnableWindow(FALSE);
			m_chkMatch.EnableWindow(FALSE);
		}
	}

}

void CPageHook::OnBnClickedChkUnicode()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		SetChildNodeFromCheckbox(pTransCmdNode, _T("UNICODE"), m_chkUnicode);
	}
}

void CPageHook::OnBnClickedChkAllsametext()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		SetChildNodeFromCheckbox(pTransCmdNode, _T("ALLSAMETEXT"), m_chkAllSameText);
	}
}


void CPageHook::OnBnClickedChkClipJpn()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		SetChildNodeFromCheckbox(pTransCmdNode, _T("CLIPJPN"), m_chkClipJpn);
	}
}

void CPageHook::OnBnClickedChkClipKor()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		SetChildNodeFromCheckbox(pTransCmdNode, _T("CLIPKOR"), m_chkClipKor);
	}
}

void CPageHook::OnBnClickedChkRemoveSpace()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		SetChildNodeFromCheckbox(pTransCmdNode, _T("REMOVESPACE"), m_chkRemoveSpace);
	}
}

void CPageHook::OnBnClickedChkTwobyte()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		SetChildNodeFromCheckbox(pTransCmdNode, _T("TWOBYTE"), m_chkTwoByte);
	}
}

void CPageHook::OnBnClickedChkSafe()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		SetChildNodeFromCheckbox(pTransCmdNode, _T("SAFE"), m_chkSafe);
	}
}

void CPageHook::SetChildNodeFromCheckbox(COptionNode* pParentNode, LPCTSTR cszChildName, CButton& checkbox)
{
	COptionNode* pNode = pParentNode->GetChild(cszChildName);

	// üũ 
	if(checkbox.GetCheck())
	{
		if(NULL==pNode)
		{
			pNode = pParentNode->CreateChild();
			pNode->SetValue(cszChildName);
		}
	}
	// üũ   
	else
	{
		if(pNode)
		{
			pParentNode->DeleteChild(pNode);
		}
	}

	if( COptionDlg::_Inst && ::IsWindow(COptionDlg::_Inst->m_btnApply.m_hWnd))
	{
		COptionDlg::_Inst->m_btnApply.EnableWindow(TRUE);
	}
}

void CPageHook::OnBnClickedBtnArgAdd()
{
	CMemoryDlg memdlg;

	if( memdlg.DoModal() == IDOK)
	{
		try
		{
			 if( NULL == m_pHookNode ) throw -1;
			
			CString strMem = _T("");

			if(memdlg.m_bCustom)
			{
				strMem = memdlg.m_strCustomMem;
			}
			else
			{
				strMem = memdlg.m_strSelectedArg;
			}
			strMem.Remove(_T(' '));

			//  ȿ ˻
			if(strMem.IsEmpty())
			{
				this->MessageBox(_T(" ޸𸮸  ֽʽÿ."), _T(""));
				throw -4;
			}

			// TRANS  
			COptionNode* pNode = m_pHookNode->CreateChild();
			if(NULL == pNode) throw -2;
			pNode->SetValue(_T("TRANS"));

			// ޸ 
			COptionNode* pMemNode = pNode->CreateChild();
			if(NULL == pMemNode) throw -3;
			pMemNode->SetValue(strMem);

			// UI 
			if( InitFromHookNode(m_pHookNode) )
			{
				int nComboIdx = m_comboTransArgs.FindString(-1, strMem);
				if(nComboIdx != CB_ERR)
				{
					m_comboTransArgs.SetCurSel(nComboIdx);
					OnCbnSelchangeComboTransArgs();
				}

				COptionDlg::_Inst->m_btnApply.EnableWindow(TRUE);				
			}
			else
			{
				m_pHookNode->DeleteChild(pNode);
				InitFromHookNode(m_pHookNode);
			}

		}
		catch (int nErrCode)
		{
			nErrCode = nErrCode;
		}
	}
}

void CPageHook::OnBnClickedBtnArgDel()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	
	if(nSelIdx >= 0)
	{
		m_pHookNode->DeleteChild( (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx) );
		InitFromHookNode(m_pHookNode);
	}

}


void CPageHook::OnBnClickedBtnDelHook()
{
	
	if( COptionDlg::_Inst && ::IsWindow(COptionDlg::_Inst->m_btnApply.m_hWnd))
	{
		CString msg = m_pHookNode->GetChild(0)->GetValue() + _T(" Ͻðڽϱ?");
		if(MessageBox(msg, _T("Delete"), MB_YESNO) == IDYES)
		{
			COptionDlg::_Inst->PostMessage(WM_DELETE_HOOK, (WPARAM)m_pHookNode, 0);
		}
		
	}
}

void CPageHook::OnBnClickedChkIgnore()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		COptionNode* pTransMethod = pTransCmdNode->GetChild(_T("OVERWRITE"));
		
		if(!pTransMethod)
			pTransMethod = pTransCmdNode->GetChild(_T("SMSTR"));
		
		if(pTransMethod)
		{
			if (m_chkMatch.GetCheck() == 1)
			{
				m_chkMatch.SetCheck(0);
				SetChildNodeFromCheckbox(pTransMethod, _T("MATCH"), m_chkMatch);
			}
			SetChildNodeFromCheckbox(pTransMethod, _T("IGNORE"), m_chkIgnore);
		}
		
	}
}

void CPageHook::OnBnClickedChkMatch()
{
	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		COptionNode* pTransMethod = pTransCmdNode->GetChild(_T("SMSTR"));
		
		if(pTransMethod)
		{
			if (m_chkIgnore.GetCheck() == 1)
			{
				m_chkIgnore.SetCheck(0);
				SetChildNodeFromCheckbox(pTransMethod, _T("IGNORE"), m_chkIgnore);
			}
			SetChildNodeFromCheckbox(pTransMethod, _T("MATCH"), m_chkMatch);
		}
		
	}
}

void CPageHook::OnBnClickedChkUselen()
{
	int nUseLen=m_chkUseLen.GetCheck();

	if (nUseLen)
	{
		m_editLenPos.EnableWindow(TRUE);
	}
	else
	{
		m_editLenPos.SetWindowText(_T(""));
		m_editLenPos.EnableWindow(FALSE);
		
		int nSelIdx = m_comboTransArgs.GetCurSel();
		COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

		if (pTransCmdNode)
		{
			SetChildNodeFromCheckbox(pTransCmdNode, _T("LEN"), m_chkUseLen);
		}
	}
}

void CPageHook::OnEnChangeEditLenpos()
{
	// TODO:  RICHEDIT Ʈ ,  Ʈ
	// CDialog::OnInitDialog() Լ  
	//ϰ ũ OR Ͽ  ENM_CHANGE ÷׸ Ͽ CRichEditCtrl().SetEventMask() ȣ 
	//  ˸ ޽  ʽϴ.

	if (m_chkUseLen.GetCheck() == 0)
		return;

	int nSelIdx = m_comboTransArgs.GetCurSel();
	COptionNode* pTransCmdNode = (COptionNode*)m_comboTransArgs.GetItemData(nSelIdx);

	if(pTransCmdNode)
	{
		COptionNode *pLenNode = pTransCmdNode->GetChild(_T("LEN"));

		CString strLenPos;

		m_editLenPos.GetWindowText(strLenPos);

		strLenPos.Trim();

		if (!strLenPos.IsEmpty())
		{
			// LEN(pos) 
			if (pLenNode == NULL)
			{
				pLenNode = pTransCmdNode->CreateChild();
				pLenNode->SetValue(_T("LEN"));
			}

			COptionNode *pLenPosNode = pLenNode->GetChild(0);

			if (pLenPosNode == NULL)
			{
				pLenPosNode = pLenNode->CreateChild();
			}

			pLenPosNode->SetValue(strLenPos);
		}
		else
		{
			if (pLenNode)
				pTransCmdNode->DeleteChild(pLenNode);
		}
		
		if( COptionDlg::_Inst && ::IsWindow(COptionDlg::_Inst->m_btnApply.m_hWnd))
		{
			COptionDlg::_Inst->m_btnApply.EnableWindow(TRUE);
		}
	}
}
