#include "StdAfx.h"

#include "TransCommand.h"
#include "OptionMgr.h"
#include "CharacterMapper.h"
#include "TransScriptParser.h"

#include "Debug.h"

#pragma warning(disable:4996)

//////////////////////////////////////////////////////////////////////////
//
// ⺻ Ŭ ޼ҵ
//
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// ɼǿ  ׿ ´ Ŭ νϽ մϴ.
//
CTransCommand *CTransCommand::CreateTransCommand(CString &strArgScript, COptionNode *pNode)
{
	CTransCommand * pCmd = NULL;

	//   
	int cnt3 = pNode->GetChildCount();

	for(int k=1; k<cnt3; k++)
	{
		COptionNode* pNode3 = pNode->GetChild(k);
		CString strTransOption = pNode3->GetValue().MakeUpper();

		// 
		if(strTransOption == _T("NOP"))
		{
			pCmd = new CTransCommandNOP();
			NOTIFY_DEBUG_MESSAGE(_T("CreateTransCommand: NOP created\n"));
			break;
		}
		else if(strTransOption == _T("PTRCHEAT"))
		{
			pCmd = new CTransCommandPTRCHEAT();

			//  ɼ м
			int cnt4 = pNode3->GetChildCount();
			for (int i=0; i<cnt4; i++)
			{
				COptionNode* pNode4 = pNode3->GetChild(i);
				pCmd->SetSpecialOption(pNode4->GetValue().MakeUpper(), pNode4);
			}
			NOTIFY_DEBUG_MESSAGE(_T("CreateTransCommand: PTRCHEAT created\n"));
			break;
		}
		else if(strTransOption == _T("OVERWRITE"))
		{
			pCmd = new CTransCommandOVERWRITE();
			NOTIFY_DEBUG_MESSAGE(_T("CreateTransCommand: OVERWRITE created\n"));

			//  ɼ м
			int cnt4 = pNode3->GetChildCount();
			for (int i=0; i<cnt4; i++)
			{
				COptionNode* pNode4 = pNode3->GetChild(i);
				pCmd->SetSpecialOption(pNode4->GetValue().MakeUpper(), pNode4);
			}
			break;
		}
		else if(strTransOption == _T("SOW"))
		{
			pCmd = new CTransCommandSOW();
			NOTIFY_DEBUG_MESSAGE(_T("CreateTransCommand: SOW created\n"));

			//  ɼ м
			int cnt4 = pNode3->GetChildCount();
			for (int i=0; i<cnt4; i++)
			{
				COptionNode* pNode4 = pNode3->GetChild(i);
				pCmd->SetSpecialOption(pNode4->GetValue().MakeUpper(), pNode4);
			}
			break;
		}
		else if(strTransOption == _T("SMSTR"))
		{
			pCmd = new CTransCommandSMSTR();
			NOTIFY_DEBUG_MESSAGE(_T("CreateTransCommand: SMSTR created\n"));

			//  ɼ м
			int cnt4 = pNode3->GetChildCount();
			for (int i=0; i<cnt4; i++)
			{
				COptionNode* pNode4 = pNode3->GetChild(i);
				pCmd->SetSpecialOption(pNode4->GetValue().MakeUpper(), pNode4);
			}
			break;
		}
		
	}

	if (!pCmd) 
	{
		pCmd = new CTransCommandNOP();
		NOTIFY_DEBUG_MESSAGE(_T("CreateTransCommand: (default) NOP created\n"));
	}

	pCmd->SetArgScript(strArgScript);

	//  ɼǵ 
	for(int k=1; k<cnt3; k++)
	{
		COptionNode* pNode3 = pNode->GetChild(k);
		pCmd->SetTransOption(pNode3->GetValue().MakeUpper(), pNode3);
	}

	return pCmd;
}

//////////////////////////////////////////////////////////////////////////
// ɼ м, մϴ.
//
void CTransCommand::SetTransOption(CString strTransOption, COptionNode *pNode)
{
	// ƼƮ / ڵ 
	if(strTransOption == _T("ANSI"))
	{
		m_bUnicode=FALSE;
		NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: ANSI\n"));
	}
	else if(strTransOption == _T("UNICODE"))
	{
		m_bUnicode=TRUE;
		NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: UNICODE\n"));
	}

	// CLIPKOR ɼ
	else if(strTransOption == _T("CLIPKOR"))
	{
		m_bClipKor=TRUE;
		NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: CLIPKOR\n"));
	}

	// CLIPJPN ɼ
	else if(strTransOption == _T("CLIPJPN"))
	{
		m_bClipJpn=TRUE;
		NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: CLIPJPN\n"));
	}

	// REMOVESPACE ɼ
	else if(strTransOption == _T("REMOVESPACE"))
	{
		m_bRemoveSpace=TRUE;
		NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: REMOVESPACE\n"));
	}

	// TWOBYTE ɼ
	else if(strTransOption == _T("TWOBYTE"))
	{
		m_bTwoByte=TRUE;
		NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: TWOBYTE\n"));
	}

	// SAFE ɼ
	else if(strTransOption == _T("SAFE"))
	{
		m_bSafe=TRUE;
		NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: SAFE\n"));
	}

	// LEN ɼ
	else if(strTransOption == _T("LEN"))
	{
		TCHAR *pszRegs[] = {_T("EAX"), _T("EBX"), _T("ECX"), _T("EDX"), _T("ESI"), _T("EDI"), _T("EBP"), _T("ESP"), NULL};
		CString strLenPos = pNode->GetChild(0)->GetValue().MakeUpper();

		int i=0;
		bool bIsExpression = false;
		while(pszRegs[i])
		{
			if (strLenPos.Find(pszRegs[i]) >= 0)
			{
				//    : 
				bIsExpression = true;
				break;
			}
			i++;
		}

		if (bIsExpression)
		{
			m_strLenPos = pNode->GetChild(0)->GetValue();
			NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: LEN(%s)\n"), m_strLenPos);
		}
		else
		{
			//  ƴ
			bool bIsMinus=false;
			i=0;
/*
			if(strLenPos[0] == _T('-'))
			{
				bIsMinus = true;
				i++;
			}
*/			
			for(; i<strLenPos.GetLength(); i++)
			{
				//   ã´
				if ( strLenPos[i] != _T('+') && strLenPos[i] != _T('X') && strLenPos[i] != _T('0') )
					break;
			}
			
			_stscanf(strLenPos.Mid(i), _T("%x"), &m_nLenPos);

			NOTIFY_DEBUG_MESSAGE(_T("SetTransOption: LEN(%d)\n"), m_nLenPos);
		}
		m_bAdjustLen = TRUE;
	}

}

//////////////////////////////////////////////////////////////////////////
//    ġ ȯմϴ.
//
void *CTransCommand::GetTextPoint(CTransScriptParser *pParser)
{
	if (pParser == NULL) return NULL;

	NOTIFY_DEBUG_MESSAGE(_T("GetTextPoint: called\n"));

	void * pArgText = NULL;

	// ArgScript ( [ESI] ..)  Ű ġ 
	int nType;
	int* pRetVal = (int*)pParser->GetValue(GetArgScript(), &nType);
	if(pRetVal && 1 == nType)
	{
		pArgText = *(LPVOID *)pRetVal;
		delete pRetVal;
	}

	//  ġ ȿ ˻
	if(pArgText == NULL || IsBadReadPtr(pArgText, sizeof(LPVOID))) 
	{
		return NULL;
	}

	if (m_bUnicode)
	{
		if (*(LPWSTR)pArgText == L'\0') 
		{
			return NULL;
		}

	}
	else // MBCS
	{
		if(*(LPSTR)pArgText == '\0') 
		{
			return NULL;
		}
	}

	m_pArgText=pArgText;
	NOTIFY_DEBUG_MESSAGE(_T("GetTextPoint: pArgText=%p\n"), pArgText);

	return pArgText;
}

//////////////////////////////////////////////////////////////////////////
// ޾ƿ ڿ   ִ ڿ Ȯմϴ.
//
BOOL CTransCommand::IsValidTextPoint(void *pArgText, long nSize)
{
	BOOL bRet = TRUE;

	NOTIFY_DEBUG_MESSAGE(_T("IsValidTextPoint: called, pArgText=%p, *pArgText=%08X\n"),pArgText, *(DWORD *) pArgText);

	if (m_bUnicode)
	{
		if( IsBadStringPtrW((LPCWSTR)pArgText, nSize) )
			bRet = FALSE;

	}
	else
	{
		if ( IsBadStringPtrA((LPCSTR)pArgText, nSize) )
			bRet = FALSE;

		// ߸ ؽƮΰ?
		if(m_bSafe && CCharacterMapper::IsShiftJISText((LPCSTR)pArgText) == FALSE)
		{
			TRACE(_T("[aral1] Bad Text \n"));
			throw -4; //_T("Ϻ ؽƮ ƴմϴ.");
		}


	}
	
	NOTIFY_DEBUG_MESSAGE(_T("IsValidTextPoint: return %s\n"), (bRet?_T("TRUE"):_T("FALSE")) );

	return bRet;
}

//////////////////////////////////////////////////////////////////////////
// Ȥ  ڿ ٽ Ϸ Ȯմϴ.
//
BOOL CTransCommand::IsDuplicateText(void *pArgText)
{
	NOTIFY_DEBUG_MESSAGE(_T("IsDuplicateText: called\n"));

	BOOL bRet=FALSE;
	if (m_bUnicode)
	{
		LPWSTR wszText = (LPWSTR) pArgText;

		// ֱ  ΰ
		wchar_t wszPureText[MAX_TEXT_LENGTH];
		wcscpy(wszPureText, wszText);
		size_t wlen = wcslen(wszPureText);

		//    
		while(wlen>0 && wszPureText[wlen-1] == L' ')
		{
			wszPureText[wlen-1] = L'\0';
			wlen--;
		}

		// ߺ üũ
		if( wcslen((LPCWSTR)m_pTransTextBuf) > 0 && wcsstr((LPCWSTR)m_pTransTextBuf, wszPureText) )
		{
		//	throw -1; //_T(" ġ ߺ Ϸ մϴ.");
			bRet = TRUE;
		}
		// ֱ ó Ϻ ƴ ο ̶		
		else if( wcscmp(wszText, (LPCWSTR)m_pOrigTextBuf) )
			bRet = FALSE;	//  ʿ
		else
			bRet = TRUE;	//  ʿ
	}
	else
	{
		LPSTR szText = (LPSTR) pArgText;

		// ֱ  ΰ
		size_t nCmpCnt = strlen(szText);

		//    
		while(nCmpCnt > 0 && szText[nCmpCnt-1] == ' ') nCmpCnt--;

		// ߺ üũ
		if( strlen((LPCSTR)m_pTransTextBuf) > 0 && strncmp(szText, (LPCSTR)m_pTransTextBuf, nCmpCnt) == 0 )
		{
		//	throw -1; //_T(" ġ ߺ Ϸ մϴ.");
			bRet = TRUE;
		}
		// ֱ ó Ϻ ƴ ο ̶
		else if( strcmp(szText, (LPCSTR)m_pOrigTextBuf) )
			bRet = FALSE;	//  ʿ
		//  Ϻ ̶ Ͱ ġ ٸ (:  ܾ  ٸ ġ  )
		else if ( pArgText != m_pPrevArgText)
			bRet = FALSE;
		else
			bRet = TRUE;	//  ʿ
	}

	NOTIFY_DEBUG_MESSAGE(_T("IsDuplicateText: return %s\n"), (bRet?_T("TRUE"):_T("FALSE")) );
	return bRet;
}

//////////////////////////////////////////////////////////////////////////
// ڿ ̸  ڿ ̷ մϴ.
//
BOOL CTransCommand::ChangeLength(void *pOrigBasePtr, CTransScriptParser *pParser, void *pNewBasePtr)
{
	if (!m_bAdjustLen) return FALSE;

	NOTIFY_DEBUG_MESSAGE(_T("ChangeLength: called\n"));

	// pNewBasePtr  Ǹ pOrigBasePtr   
	if (pNewBasePtr == NULL)
		pNewBasePtr = pOrigBasePtr;

	int *pnLen=NULL;

	// ̰  ġ ã´
	if (m_nLenPos)
	{
		// m_nLenPos  ִٸ pOrigBasePtr ġ 
		pnLen = (int *)((DWORD)pOrigBasePtr + m_nLenPos);
	}
	else if (!m_strLenPos.IsEmpty())
	{
		// m_strLenPos  ִٸ ״ ļ ־ 
		int nType;
		int *pRetVal = (int *)pParser->GetValue(m_strLenPos, &nType);

		if (pRetVal && 1 == nType)
		{
			pnLen = *(int **)pRetVal;
			delete pRetVal;

		}
		else
			return FALSE;
	}
	else
		return FALSE;

	if (IsBadReadPtr(pnLen, sizeof(int *)))
	{
		NOTIFY_DEBUG_MESSAGE(_T("ChangeLength: Cannot read address %p\n"), pnLen);
		return FALSE;
	}

	// ã ̰ Ȯ Ȯϰ  Ʈ¥ ȮѴ.
	int nOrigLen = (m_bUnicode ? lstrlenW((LPCWSTR)m_pOrigTextBuf) : lstrlenA((LPCSTR)m_pOrigTextBuf));
	int nTempLen = *pnLen;
	int nBytes;
	bool bIsNullIncluded=false;

	if (nOrigLen == nTempLen)
		nBytes=4;
	else if (nOrigLen == (nTempLen & 0x0FFFF))
		nBytes=2;
	else if (nOrigLen == (nTempLen & 0x0FF))
		nBytes=1;
	else
	{
		// NULL  Ե  ѹ  üũ
		nOrigLen++;
		if (nOrigLen == nTempLen)
		{
			bIsNullIncluded=true;
			nBytes=4;
		}
		else if (nOrigLen == (nTempLen & 0x0FFFF))
		{
			bIsNullIncluded=true;
			nBytes=2;
		}
		else if (nOrigLen == (nTempLen & 0x0FF))
		{
			bIsNullIncluded=true;
			nBytes=1;
		}
		else
			return FALSE;
	}

	NOTIFY_DEBUG_MESSAGE(_T("ChangeLength: address(%p), bytes(%d), nOrigLen=%d, nTempLen=%d, bIsNullIncluded=%s\n"),
			pnLen, nBytes, nOrigLen, nTempLen, (bIsNullIncluded?_T("TRUE"):_T("FALSE")));

	//   ̷ ٲִ´.

	if (m_nLenPos)
	{
		pnLen = (int *)((DWORD)pNewBasePtr + m_nLenPos);
	}

	if (IsBadWritePtr(pnLen, sizeof(int)))
	{
		NOTIFY_DEBUG_MESSAGE(_T("ChangeLength: Cannot write address %p\n"), pnLen);
		return FALSE;
	}

	nTempLen = (m_bUnicode ? lstrlenW((LPCWSTR)m_pTransTextBuf) : lstrlenA((LPCSTR)m_pTransTextBuf));

	if (bIsNullIncluded)
		nTempLen++;

	if (nBytes == 1)
		*(BYTE *)pnLen = nTempLen & 0x0FF;
	else if (nBytes == 2)
		*(WORD *)pnLen = nTempLen & 0x0FFFF;
	else
		*pnLen = nTempLen;


	NOTIFY_DEBUG_MESSAGE(_T("ChangeLength: success (address:%p, %d -> %d)\n"), pnLen, nOrigLen, nTempLen);

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//
// PTRCHEAT  Ŭ ޼ҵ
//
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// ڿ ̸  ڿ ̷ մϴ. (̵)
//
BOOL CTransCommandPTRCHEAT::ChangeLength(void *pOrigBasePtr, CTransScriptParser *pParser, void *pNewBasePtr)
{
	if (!m_bAdjustLen) return FALSE;

	NOTIFY_DEBUG_MESSAGE(_T("PTRCHEAT: ChangeLength: m_pTransTextBuf(%p)\n"), m_pTransTextBuf);
	return CTransCommand::ChangeLength(pOrigBasePtr, pParser, m_pTransTextBuf);

}


//////////////////////////////////////////////////////////////////////////
//  ڿ  α׷ մϴ. (̵)
//
BOOL CTransCommandPTRCHEAT::ApplyTranslatedText(void *pArgText, PREGISTER_ENTRY pRegisters, CTransScriptParser *pParser, BOOL bIsDuplicated)
{
	if (bIsDuplicated)
	{
		if (pArgText != m_pPrevArgText)
			return FALSE;

		if (pArgText == m_pTransTextBuf)
			return FALSE;
	}

	CString strScript = m_strArgScript;
	int nLen = strScript.GetLength();

	NOTIFY_DEBUG_MESSAGE(_T("PTRCHEAT: ApplyTranslatedText: called\n"));

#if defined(_DEBUG) || defined(FORCE_DEBUG_LOG)

	if (m_bUnicode)
	{
		NOTIFY_DEBUG_MESSAGE(_T("PTRCHEAT::ApplyTranslatedText: szSrc =%s\n"), (LPCWSTR)m_pTransTextBuf);
		NOTIFY_DEBUG_MESSAGE(_T("PTRCHEAT::ApplyTranslatedText: szDest =%s\n"), (LPCWSTR)m_pOrigTextBuf);
	}
	else
	{
		WCHAR wszTemp[MAX_TEXT_LENGTH];
		MyMultiByteToWideChar(949, 0, (LPCSTR)m_pTransTextBuf, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("PTRCHEAT::ApplyTranslatedText: szSrc =%s\n"), wszTemp);
		MyMultiByteToWideChar(932, 0, (LPCSTR)m_pOrigTextBuf, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("PTRCHEAT::ApplyTranslatedText: szDest=%s\n"), wszTemp);
	}
#endif

	if(strScript.CompareNoCase(_T("EAX")) == 0) pRegisters->_EAX = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(strScript.CompareNoCase(_T("EBX")) == 0) pRegisters->_EBX = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(strScript.CompareNoCase(_T("ECX")) == 0) pRegisters->_ECX = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(strScript.CompareNoCase(_T("EDX")) == 0) pRegisters->_EDX = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(strScript.CompareNoCase(_T("ESI")) == 0) pRegisters->_ESI = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(strScript.CompareNoCase(_T("EDI")) == 0) pRegisters->_EDI = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(strScript.CompareNoCase(_T("EBP")) == 0) pRegisters->_EBP = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(strScript.CompareNoCase(_T("ESP")) == 0) pRegisters->_ESP = (DWORD)(UINT_PTR)m_pTransTextBuf;
	else if(nLen >= 5 && _T('[') == strScript[0] && _T(']') == strScript[nLen-1])
	{
		int nType;
		int* pRetVal = (int*)pParser->GetValue(strScript.Mid(1, nLen-2), &nType);
		if(pRetVal && 1 == nType)
		{
			LPBYTE* ppArgText = *(LPBYTE**)pRetVal;
			delete pRetVal;

			if(::IsBadWritePtr(ppArgText, sizeof(LPBYTE)) == FALSE)
			{
				*ppArgText = m_pTransTextBuf;
			}

		}
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//
// OVERWRITE  Ŭ ޼ҵ
//
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// ɼ м, մϴ.
//
void CTransCommandOVERWRITE::SetTransOption(CString strTransOption, COptionNode *pNode)
{
	if (strTransOption == _T("ALLSAMETEXT"))
	{
		NOTIFY_DEBUG_MESSAGE(_T("OVERWRITE: SetTransOption: ALLSAMETEXT\n"));
		m_bAllSameText=TRUE;
	}
	else
		CTransCommand::SetTransOption(strTransOption, pNode);	// global options
}

//////////////////////////////////////////////////////////////////////////
// Ư ɼ м, մϴ.
//
void CTransCommandOVERWRITE::SetSpecialOption(CString strSpecialOption, COptionNode *pNode)
{
	if(strSpecialOption == _T("IGNORE"))
	{
		NOTIFY_DEBUG_MESSAGE(_T("OVERWRITE: SetSpecialOption: IGNORE\n"));
		m_bIgnoreBufLen=TRUE;
	}
	else
		CTransCommand::SetSpecialOption(strSpecialOption, pNode);
}

//////////////////////////////////////////////////////////////////////////
//   α׷ ϴ.
//
BOOL CTransCommandOVERWRITE::OverwriteTextBytes( LPVOID pDest, LPVOID pSrc )
{
	NOTIFY_DEBUG_MESSAGE(_T("OVERWRITE: OverwriteTextBytes: called\n"));

	if(m_bUnicode)
	{
		LPWSTR wszSrc = (LPWSTR)pSrc;
		UINT_PTR nSrcLen = wcslen(wszSrc);
		LPWSTR wszDest = (LPWSTR)pDest;
		UINT_PTR nDestLen = ( m_bIgnoreBufLen ? nSrcLen : wcslen(wszDest) );

		// ڿ Ͱ ߸Ǿٸ 
		if( IsBadWritePtr(wszDest, nDestLen) || IsBadStringPtrW(wszDest, 1024*1024*1024) ) return FALSE;

		// ؽƮ 
		size_t len = min(nDestLen, nSrcLen);
		memcpy(wszDest, wszSrc, (len+1)*sizeof(wchar_t));
		while(len<nDestLen)
		{
			wszDest[len] = L' ';
			len++;
		}

	}
	else
	{

		LPSTR szSrc = (LPSTR)pSrc;
		UINT_PTR nSrcLen = strlen(szSrc);
		LPSTR szDest = (LPSTR)pDest;
		UINT_PTR nDestLen = ( m_bIgnoreBufLen ? nSrcLen : strlen(szDest) );


#if defined(_DEBUG) || defined(FORCE_DEBUG_LOG)
		WCHAR wszTemp[MAX_TEXT_LENGTH];
		MyMultiByteToWideChar(949, 0, szSrc, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("OVERWRITE: OverwriteTextBytes: szSrc =%s\n"), wszTemp);
		MyMultiByteToWideChar(932, 0, szDest, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("OVERWRITE: OverwriteTextBytes: szDest=%s\n"), wszTemp);
#endif


		// ڿ Ͱ ߸Ǿٸ 
		if( IsBadWritePtr(szDest, nDestLen) || IsBadStringPtrA(szDest, 1024*1024*1024) ) return FALSE;

		// ؽƮ 
		size_t len = 0;
		while(len<nDestLen && len<nSrcLen)
		{
			size_t addval = 1;
			if( (BYTE)0x80 <= (BYTE)szSrc[len] ) addval = 2;

			if( len + addval > nDestLen ) break;

			len += addval;
		}

		memcpy(szDest, szSrc, (len+1));
		while(len<nDestLen)
		{
			szDest[len] = ' ';
			len++;
		}
	}

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//      ã  ϴ.
// (ANSI )
//
BOOL CTransCommandOVERWRITE::SearchTextA(UINT_PTR ptrBegin, LPCSTR cszText, list<LPVOID>* pTextList)
{
	BOOL bRetVal = FALSE;

	size_t dist = 0;
	size_t nOrigLen = strlen(cszText);

	while( IsBadReadPtr((void*)(ptrBegin+dist), sizeof(void*)) == FALSE )
	{
		LPSTR* ppText = (LPSTR*)(ptrBegin+dist);

		// ġѴٸ
		if( IsBadStringPtrA(*ppText, 1024*1024*1024)==FALSE 
			&& strlen(*ppText) == nOrigLen
			&& strcmp(*ppText, cszText) == 0 )
		{
			// Ͽ ߰
			pTextList->push_back(*ppText);
			bRetVal = TRUE;
		}

		dist += sizeof(void*);
	}

	TRACE(_T(" [ aral1 ] SearchTextA ãŸ:0x%p~0x%p (%d bytes) \n"), ptrBegin, ptrBegin+dist, dist);

	return bRetVal;
}

//////////////////////////////////////////////////////////////////////////
//      ã  ϴ.
// (UNICODE )
//
BOOL CTransCommandOVERWRITE::SearchTextW(UINT_PTR ptrBegin, LPCWSTR cwszText, list<LPVOID>* pTextList)
{
	BOOL bRetVal = FALSE;

	size_t dist = 0;
	size_t nOrigLen = wcslen(cwszText);

	while( IsBadReadPtr((void*)(ptrBegin+dist), sizeof(void*)) == FALSE )
	{
		LPWSTR* ppText = (LPWSTR*)(ptrBegin+dist);

		// ġѴٸ
		if( IsBadStringPtrW(*ppText, 1024*1024)==FALSE 
			&& wcslen(*ppText) == nOrigLen
			&& wcscmp(*ppText, cwszText) == 0 )
		{
			// Ͽ ߰
			pTextList->push_back(*ppText);
			bRetVal = TRUE;
		}

		dist += sizeof(void*);

	}	

	TRACE(_T(" [ aral1 ] SearchTextW ãŸ:0x%p~0x%p (%d bytes) \n"), ptrBegin, ptrBegin+dist, dist);

	return bRetVal;
}

//////////////////////////////////////////////////////////////////////////
//   ڿ  α׷ մϴ. (̵)
//
BOOL CTransCommandOVERWRITE::ApplyTranslatedText(void *pArgText, PREGISTER_ENTRY pRegisters, CTransScriptParser *pParser, BOOL bIsDuplicated)
{
	if (bIsDuplicated)
	{
		if (m_bUnicode)
		{
			if (*(WCHAR *)m_pTransTextBuf == L'\0')
				return FALSE;
		}
		else
		{
			if (*(char *)m_pTransTextBuf == '\0')
				return FALSE;
		}
		//  ۿ   ״ Ѵ.
	}

	NOTIFY_DEBUG_MESSAGE(_T("OVERWRITE: ApplyTranslatedText: called\n"));

	list<LPVOID> listTexts;
	listTexts.push_back(pArgText);
	

	// ؾ ġ 
	if(m_bAllSameText)
	{
		if(m_bUnicode)
		{
			SearchTextW((UINT_PTR)pRegisters->_EBP, (LPCWSTR)pArgText, &listTexts);
		}
		else
		{
			SearchTextA((UINT_PTR)pRegisters->_EBP, (LPCSTR)pArgText, &listTexts);
		}
	}


	// ġ鿡  ؽƮ Overwrite
	for(list<LPVOID>::iterator iter = listTexts.begin();
		iter != listTexts.end();
		iter++)
	{
		LPVOID pDest = (*iter);
		OverwriteTextBytes(pDest, m_pTransTextBuf);
	}
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//
// SOW  Ŭ ޼ҵ
//
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// SOW  ޸𸮸 ϰ  ϴ
//
void CTransCommandSOW::DoBackupAndOverwrite(const PBYTE pBackupPoint, UINT nBackupSize)
{
	//   Ǿ  
	if (m_pBackupPoint)
		RestoreBackup();

	NOTIFY_DEBUG_MESSAGE(_T("SOW: DoBackupAndOverwrite: called\n"));

	m_pBackupBuffer = new BYTE [nBackupSize];
	m_nBackupSize = nBackupSize;
	m_pBackupPoint = pBackupPoint;

	// 
	CopyMemory(m_pBackupBuffer, m_pBackupPoint, m_nBackupSize);

	if (m_nLenBytes)
	{
		int nLen = (m_bUnicode ? lstrlenW((LPCWSTR)m_pTransTextBuf) : lstrlenA((LPCSTR)m_pTransTextBuf));
		if (m_bIsNullIncluded)
			nLen++;

		try
		{
		//  ġ ġ ġ ϰ
		if (!m_pnBackupLenPoint)
			m_pnBackupLenPoint = (int *)(pBackupPoint + m_nLenPos);

		NOTIFY_DEBUG_MESSAGE(_T("SOW: DoBackupAndOverwrite: m_pnBackupLenPoint=%p\n"), m_pnBackupLenPoint);

		if (IsBadReadPtr(m_pnBackupLenPoint, sizeof(int *)))
		{
			NOTIFY_DEBUG_MESSAGE(_T("SOW: DoBackupAndOverwrite: BadReadPtr m_pnBackupLenPoint\n"));
			throw;
		}

		if (IsBadWritePtr(m_pnBackupLenPoint, sizeof(int)))
		{
			NOTIFY_DEBUG_MESSAGE(_T("SOW: DoBackupAndOverwrite: BadWritePtr m_pnBackupLenPoint\n"));

		}

		// ̰  ġ  
		m_nBackupLenPoint = *m_pnBackupLenPoint;

		//  
		if (m_nLenBytes == 1)
			*(BYTE *)m_pnBackupLenPoint = nLen & 0x0FF;
		else if (m_nLenBytes == 2)
			*(WORD *)m_pnBackupLenPoint = nLen & 0x0FFFF;
		else
			*m_pnBackupLenPoint = nLen;

		NOTIFY_DEBUG_MESSAGE(_T("SOW: DoBackupAndOverwrite: Len changed to %d\n"), nLen);

		// ۾ ϷḦ ǥϱ  m_nLenBytes  0  
		m_nLenBytes = 0;

		}
		catch (...)
		{
			m_pnBackupLenPoint = NULL;
			m_nLenBytes = 0;
			m_nBackupLenPoint = 0;
		}

	}

	// 
	CopyMemory(m_pBackupPoint, m_pTransTextBuf, m_nBackupSize);

}

//////////////////////////////////////////////////////////////////////////
// SOW   Ÿ մϴ
//
void CTransCommandSOW::RestoreBackup()
{
	NOTIFY_DEBUG_MESSAGE(_T("SOW: RestoreBackup: called\n"));

	if (m_pBackupPoint)
	{
		//  ޸𸮰 Ⱑ   
		if (!IsBadWritePtr(m_pBackupPoint, m_nBackupSize))
		{
			bool bIsMismatch = false;
			UINT i;

			//  ޸𸮰   ٲ üũ
			for(i=0; i<m_nBackupSize; i++)
			{
				if (*(m_pBackupPoint+i) != *(m_pTransTextBuf+i))
				{
					bIsMismatch=true;
					break;
				}
			}

			// ٲ ʾ 
			if (!bIsMismatch)
			{
				CopyMemory(m_pBackupPoint, m_pBackupBuffer, m_nBackupSize);

				// m_nLenBytes == 0 ε m_pnBackupLenPoint  ϸ ڱ 
				if (m_nLenBytes == 0 && m_pnBackupLenPoint)
				{
					*m_pnBackupLenPoint = m_nBackupLenPoint;

					m_pnBackupLenPoint = NULL;
					m_nBackupLenPoint = 0;
					NOTIFY_DEBUG_MESSAGE(_T("SOW: RestoreBackup: Len restored\n"));
				}

			}
		}
		delete[] m_pBackupBuffer;
		m_pBackupPoint=NULL;


	}

}

//////////////////////////////////////////////////////////////////////////
// ڿ ̸  ڿ ̷ մϴ. (̵)
//
BOOL CTransCommandSOW::ChangeLength(void *pOrigBasePtr, CTransScriptParser *pParser, void *pNewBasePtr)
{
	// SOW Ŀ  Ͱ Ǵ ̱  ⼭   ʰ
	// ڿ  Ȯθ      DoBackupAndOverwrite  Ѵ.

	if (!m_bAdjustLen) return FALSE;

	NOTIFY_DEBUG_MESSAGE(_T("SOW: ChangeLength: called\n"));

	int *pnLen=NULL;

	// ̰  ġ ã´
	if (m_nLenPos)
	{
		// m_nLenPos  ִٸ pOrigBasePtr ġ 
		pnLen = (int *)((DWORD)pOrigBasePtr + m_nLenPos);
	}
	else if (!m_strLenPos.IsEmpty())
	{
		// m_strLenPos  ִٸ ״ ļ ־ 
		int nType;
		int *pRetVal = (int *)pParser->GetValue(m_strLenPos, &nType);

		if (pRetVal && 1 == nType)
		{
			pnLen = *(int **)pRetVal;
			delete pRetVal;

		}
		else
		{
			m_nLenBytes=0;
			return FALSE;
		}
	}
	else
	{
		m_nLenBytes=0;
		return FALSE;
	}

	if (IsBadReadPtr(pnLen, sizeof(int *)))
	{
		NOTIFY_DEBUG_MESSAGE(_T("ChangeLength: Cannot read address %p\n"), pnLen);
		m_nLenBytes=0;
		return FALSE;
	}

	// ã ̰ Ȯ Ȯϰ  Ʈ¥ ȮѴ.
	int nOrigLen = (m_bUnicode ? lstrlenW((LPCWSTR)m_pOrigTextBuf) : lstrlenA((LPCSTR)m_pOrigTextBuf));
	int nTempLen = *pnLen;
	int nBytes;
	bool bIsNullIncluded=false;

	if (nOrigLen == nTempLen)
		nBytes=4;
	else if (nOrigLen == (nTempLen & 0x0FFFF))
		nBytes=2;
	else if (nOrigLen == (nTempLen & 0x0FF))
		nBytes=1;
	else
	{
		// NULL  Ե  ѹ  üũ
		nOrigLen++;
		if (nOrigLen == nTempLen)
		{
			bIsNullIncluded=true;
			nBytes=4;
		}
		else if (nOrigLen == (nTempLen & 0x0FFFF))
		{
			bIsNullIncluded=true;
			nBytes=2;
		}
		else if (nOrigLen == (nTempLen & 0x0FF))
		{
			bIsNullIncluded=true;
			nBytes=1;
		}
		else
		{
			m_nLenBytes=0;
			return FALSE;
		}
	}

	// ʿ Ÿ nBytes, bIsNullIncluded.
	m_nLenBytes = nBytes;
	m_bIsNullIncluded = bIsNullIncluded;

	//  LEN()   ڿ  ġ ʿ.
	if (!m_strLenPos.IsEmpty())
		m_pnBackupLenPoint = pnLen;

	NOTIFY_DEBUG_MESSAGE(_T("SOW: ChangeLength: address(%p), bytes(%d), nOrigLen=%d, nTempLen=%d, bIsNullIncluded=%s\n"),
			pnLen, nBytes, nOrigLen, nTempLen, (bIsNullIncluded?_T("TRUE"):_T("FALSE")));

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//   ڿ  α׷ մϴ. (̵)
//
BOOL CTransCommandSOW::ApplyTranslatedText(void *pArgText, PREGISTER_ENTRY pRegisters, CTransScriptParser *pParser, BOOL bIsDuplicated)
{
	if (bIsDuplicated)
	{
		if (m_bUnicode)
		{
			if (*(WCHAR *)m_pTransTextBuf == L'\0')
				return FALSE;
		}
		else
		{
			if (*(char *)m_pTransTextBuf == '\0')
				return FALSE;
		}
		//  ۿ   ״ Ѵ.
	}

	NOTIFY_DEBUG_MESSAGE(_T("SOW: ApplyTranslatedText: called\n"));

	int nOrigSize=0, nTransSize=0, nDelta=0;

	CString strScript = m_strArgScript;
	int nLen = strScript.GetLength();

	LPBYTE *ppArgText=NULL;

#if defined(_DEBUG) || defined(FORCE_DEBUG_LOG)

	if (m_bUnicode)
	{
		NOTIFY_DEBUG_MESSAGE(_T("SOW::ApplyTranslatedText: szSrc =%s\n"), (LPCWSTR)m_pTransTextBuf);
		NOTIFY_DEBUG_MESSAGE(_T("SOW::ApplyTranslatedText: szDest =%s\n"), (LPCWSTR)m_pOrigTextBuf);
	}
	else
	{
		WCHAR wszTemp[MAX_TEXT_LENGTH];
		MyMultiByteToWideChar(949, 0, (LPCSTR)m_pTransTextBuf, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("SOW::ApplyTranslatedText: szSrc =%s\n"), wszTemp);
		MyMultiByteToWideChar(932, 0, (LPCSTR)m_pOrigTextBuf, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("SOW::ApplyTranslatedText: szDest=%s\n"), wszTemp);
	}
#endif

	// ̸ ϰ
	if (m_bUnicode)
	{
		nOrigSize=wcslen((LPWSTR) m_pOrigTextBuf) *2;
		nTransSize=wcslen((LPWSTR) m_pTransTextBuf) *2;
	}
	else
	{
		nOrigSize=strlen((LPSTR) m_pOrigTextBuf);
		nTransSize=strlen((LPSTR) m_pTransTextBuf);
	}

	//   
	nDelta = nOrigSize - nTransSize;

	NOTIFY_DEBUG_MESSAGE(_T("pArgText=%p, BackupPoint=%p\n"), pArgText, (LPBYTE)pArgText + nDelta);
	DoBackupAndOverwrite((LPBYTE)pArgText + nDelta, nTransSize);

	//  ġ 
	if(strScript.Left(3).CompareNoCase(_T("EAX")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_EAX);
	else if(strScript.Left(3).CompareNoCase(_T("EBX")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_EBX);
	else if(strScript.Left(3).CompareNoCase(_T("ECX")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_ECX);
	else if(strScript.Left(3).CompareNoCase(_T("EDX")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_EDX);
	else if(strScript.Left(3).CompareNoCase(_T("ESI")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_ESI);
	else if(strScript.Left(3).CompareNoCase(_T("EDI")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_EDI);
	else if(strScript.Left(3).CompareNoCase(_T("EBP")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_EBP);
	else if(strScript.Left(3).CompareNoCase(_T("ESP")) == 0) ppArgText=(LPBYTE *)&(pRegisters->_ESP);
	else if(nLen >= 5 && _T('[') == strScript[0])
	{
		int nType;
		int nBracketCount=0;
		int i;
		int *pRetVal;

		for(i=0; i < nLen; i++)
		{
			if (strScript[i] == _T('['))
				nBracketCount++;
			else if (strScript[i] == _T(']'))
				nBracketCount--;

			if (nBracketCount == 0)
			{
				i++;
				break;
			}
		}

		pRetVal = (int*)pParser->GetValue(strScript.Mid(1, i-2), &nType);
		if(pRetVal && 1 == nType)
		{
			ppArgText = *(LPBYTE**)pRetVal;
			delete pRetVal;
		}
	}

	if (ppArgText && !IsBadWritePtr(ppArgText, sizeof(LPBYTE)))
		*ppArgText += nDelta;
	else
		return FALSE;

	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
//
// SMSTR  Ŭ ޼ҵ
//
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
// Ư ɼ м, մϴ.
//
void CTransCommandSMSTR::SetSpecialOption(CString strSpecialOption, COptionNode *pNode)
{
	if(strSpecialOption == _T("IGNORE"))
	{
		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: SetSpecialOption: IGNORE\n"));
		m_bIgnoreBufLen=TRUE;
	}
	else if(strSpecialOption == _T("MATCH"))
	{
		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: SetSpecialOption: MATCH\n"));
		m_bMatchSize=TRUE;
	}
	else
		CTransCommand::SetSpecialOption(strSpecialOption, pNode);
}

//////////////////////////////////////////////////////////////////////////
//    ġ ȯմϴ. (̵)
//
void *CTransCommandSMSTR::GetTextPoint(CTransScriptParser *pParser)
{
	if (pParser == NULL) return NULL;

	NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: called\n"));

	void * pArgText = NULL;

	// ArgScript ( [ESI] ..)  Ű ġ 
	int nType;
	int* pRetVal = (int*)pParser->GetValue(GetArgScript(), &nType);
	if(pRetVal && 1 == nType)
	{
		pArgText = *(LPVOID *)pRetVal;
		delete pRetVal;
	}

	//  ġ ȿ ˻ (SMSTR Ÿ ũ 6 DWORD (24 Ʈ))
	if(pArgText == NULL || IsBadReadPtr(pArgText, sizeof(DWORD) * 6)) return NULL;

	m_pArgText=pArgText;

	NOTIFY_DEBUG_MESSAGE(_T("  m_pArgText=%p\n "), m_pArgText);
	NOTIFY_DEBUG_MESSAGE(_T("  %08X %08X %08X %08X %08X %08X\n"), 
		*(&(*(DWORD*)pArgText)+0), *(&(*(DWORD*)pArgText)+1), *(&(*(DWORD*)pArgText)+2),
		*(&(*(DWORD*)pArgText)+3), *(&(*(DWORD*)pArgText)+4), *(&(*(DWORD*)pArgText)+5));

	if (m_bUnicode)
	{
		LPWSTR wszText = NULL;
		DWORD dwLen = *(&(*(DWORD*)pArgText)+4);

		if(dwLen == 0)
		{
			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: dwLen=0\n"));
			return NULL;
		}
		else if(dwLen >= 0x08)	// ڼ 8 (16Ʈ) ̻϶
		{
			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: Unicode Long\n"));
			// pArgText  Ű Ͱ ̸ 
			if (*(DWORD *)pArgText == NULL) return NULL;

			// ڼ ̸ 
			if(dwLen > 0x100) return NULL;

			// pArgText  Ű ۰ бҰ 
			if ( IsBadReadPtr((WCHAR *)pArgText, sizeof(WCHAR) * (dwLen + 1)) )
				return NULL;

			DWORD dwTest=0;

			//  ڼ  ڼ Ȯ üũ
			while(dwTest < dwLen){
				if(*(&(*(WCHAR*)(*(&(*(DWORD*)pArgText))))+dwTest)==L'\0'){
					return NULL;
				}
				dwTest++;
			}

			// ڼ ̻ ٸ Ÿ ִ üũ
			if(*(&(*(WCHAR*)(*(&(*(DWORD*)pArgText))))+dwLen)!=L'\0'){
				return NULL;
			}
			
			//  ؽƮ ġ pArgText  Ű ޸
			wszText = (LPWSTR)*(&(*(DWORD*)pArgText));		
		}
		else	// ڼ 8 (16Ʈ) ̸϶
		{
			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: Unicode Short\n"));
			DWORD dwTest=0;

			//  ڼ  ڼ Ȯ üũ
			while(dwTest < dwLen){
				if((*(&(*(WCHAR*)pArgText)+dwTest))==L'\0'){
					return NULL;
				}
				dwTest++;
			}

			// ڼ ̻ ٸ Ÿ ִ üũ
			if(*(&(*(WCHAR*)pArgText)+dwLen)!=L'\0'){
				return NULL;
			}
			
			//  ڴ pArgText ִ
			wszText = (LPWSTR)pArgText;
		}

		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: %p\n"), wszText);
		return wszText;

		/*&if (pCmd->GetSmbuf() &&  pCmd->GetTransMethod() == TRANSCOMMAND_OVERWRITE ){
			if(*(&(*(DWORD*)pArgText)+4) >= 0x08) continue;
		}*/

	}
	else // MBCS
	{
		LPSTR szText = NULL;
		DWORD dwLen = *(&(*(DWORD*)pArgText)+4);

		if(dwLen == 0)
		{
			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: dwLen=0\n"));
			return NULL;
		}
		else if(dwLen >= 0x10)	// ڼ 16 (16Ʈ) ̻϶
		{
			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: ANSI Long\n"));
			// pArgText  Ű Ͱ ̸ 
			if (*(DWORD *)pArgText == NULL) return NULL;

			// ڼ ̸ 
			if(dwLen > 0x100) return FALSE;

			// pArgText  Ű ۰ бҰ 
			if ( IsBadReadPtr((CHAR *)pArgText, sizeof(CHAR) * (dwLen + 1)) )
				return NULL;

			DWORD dwTest=0;
			
			//  ڼ  ڼ Ȯ üũ
			while(dwTest < dwLen){
				if(*(&(*(CHAR*)(*(&(*(DWORD*)pArgText))))+dwTest)=='\0'){
					return NULL;
				}
				dwTest++;
			}

			// ڼ ̻ ٸ Ÿ ִ üũ
			if(*(&(*(CHAR*)(*(&(*(DWORD*)pArgText))))+dwLen)!='\0'){
				return NULL;
			}
			
			//  ؽƮ ġ pArgText  Ű ޸
			szText = (LPSTR)*(&(*(DWORD*)pArgText));
		}
		else 	// ڼ 8 (16Ʈ) ̸϶
		{
			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: ANSI Short\n"));
			DWORD dwTest=0;

			//  ڼ  ڼ Ȯ üũ
			while(dwTest < dwLen){
				if((*(&(*(CHAR*)pArgText)+dwTest))=='\0'){
					return NULL;
				}
				dwTest++;
			}

			// ڼ ̻ ٸ Ÿ ִ üũ
			if(*(&(*(CHAR*)pArgText)+dwLen)!='\0'){
				return NULL;
			}
			
			//  ڴ pArgText ִ
			szText = (LPSTR)pArgText;
		}

		/*if (pCmd->GetSmbuf() &&  pCmd->GetTransMethod() == TRANSCOMMAND_OVERWRITE ){
			if(*(&(*(DWORD*)pArgText)+4) >= 0x10) continue;
		}*/

		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: GetTextPoint: %p\n"), szText);
		return szText;

	}

}
//////////////////////////////////////////////////////////////////////////
//  ̿  Ʈ ڿ ŵϴ.
//
BOOL CTransCommandSMSTR::ApplySmartString( LPVOID pDest, LPVOID pSrc )
{
	NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: called\n"));

	void *pMain = m_pArgText;

	DWORD sLen;
	BOOL bWasLongMode;

	if(m_bUnicode)	// Unicode
	{
		LPWSTR wszSrc = (LPWSTR)pSrc;
		UINT_PTR nSrcLen =  wcslen(wszSrc);
		LPWSTR wszDest = (LPWSTR)pDest;
		// MATCH  OVERWRITE IGNORE  ݴ밳̹Ƿ  ݴ
		UINT_PTR nDestLen = (m_bMatchSize ? wcslen(wszDest) : nSrcLen);	

		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: wszSrc =%s\n"), wszSrc);
		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: wszDest=%s\n"), wszDest);

		//   ڿ̾ üũ
		if (*(&(*(DWORD*)pMain)+4) >= 0x8)
			bWasLongMode = TRUE;
		else
			bWasLongMode = FALSE;

		// ڿ Ͱ ߸Ǿٸ 
		if( IsBadWritePtr(wszDest, nDestLen) || IsBadStringPtrW(wszDest, 1024*1024*1024) ) return FALSE;


		// dwLen ڸ ٲ ڱ̸ ְ
		*(&(*(DWORD*)pMain)+4) = (DWORD)nDestLen;

		// i  
		int i=1;
		sLen = (DWORD)nDestLen;

/*		//  
		while(sLen>=0x8){
			i++;
			sLen-=0x8;
		}
		i=(i*0x8)-0x1;
*/
		// ٸ 
		i=(sLen/0x8+1) * 0x8 - 1;

		//  i  ְ
		*(&(*(DWORD*)pMain)+5) = (DWORD)i;

		sLen = (DWORD)nDestLen;
		if(sLen >= 0x8){
			//  ڿ

			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: Unicode long\n"));

			//   
			// ZeroMemory(pMain, sizeof(DWORD) * 4);

			//  
			if (m_bMatchSize)	//  
			{
				size_t len = min(nDestLen, nSrcLen);
				memcpy(wszDest, wszSrc, (len+1)*sizeof(wchar_t));
				while(len<nDestLen)
				{
					wszDest[len] = L' ';
					len++;
				}
			}
			else if (m_bIgnoreBufLen)	// ۱ 
			{
				if (bWasLongMode)	//  ϴ ۰ ִ
				{
					lstrcpyW(wszDest, wszSrc);	// ۿ 
				}
				else	//  ª ڿ ( )
				{
					//  
					*(WCHAR **)pMain = wszSrc;
				}
			}
			else	// ⺻ 
			{
				//  
				*(WCHAR **)pMain = wszSrc;
			}
		}
		else
		{
			// ª ڿ

			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: Unicode short\n"));

			//   
			ZeroMemory(pMain, sizeof(DWORD) * 4);

			//  
			if (m_bMatchSize)	//  
			{
				size_t len = min(nDestLen, nSrcLen);
				memcpy(wszDest, wszSrc, (len+1)*sizeof(wchar_t));
				while(len<nDestLen)
				{
					wszDest[len] = L' ';
					len++;
				}
			}
			else	// ۱  & ⺻  
			{
				// ڿ 
				lstrcpyW((WCHAR *)pMain, wszSrc);
			}
		}

/*		// ̰ ?
		nDestLen=nSrcLen;
		if(nDestLen==0){
			return TRUE;
		}
*/
	}
	else	// MBCS
	{

		// MATCH  OVERWRITE IGNORE  ݴ밳̹Ƿ  ݴ
		LPSTR szSrc = (LPSTR)pSrc;
		UINT_PTR nSrcLen =  strlen(szSrc);
		LPSTR szDest = (LPSTR)pDest;
		UINT_PTR nDestLen = (m_bMatchSize ? strlen(szDest) : nSrcLen);

#if defined(_DEBUG) || defined(FORCE_DEBUG_LOG)
		WCHAR wszTemp[MAX_TEXT_LENGTH];

		MyMultiByteToWideChar(949, 0, szSrc, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: szSrc =%s\n"), wszTemp);
		MyMultiByteToWideChar(932, 0, szDest, -1, wszTemp, MAX_TEXT_LENGTH);
		NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: szDest=%s\n"), wszTemp);
#endif

		//   ڿ̾ üũ
		if (*(&(*(DWORD*)pMain)+4) >= 0x10)
			bWasLongMode = TRUE;
		else
			bWasLongMode = FALSE;
	
		// ڿ Ͱ ߸Ǿٸ 
		if( IsBadWritePtr(szDest, nDestLen) || IsBadStringPtrA(szDest, 1024*1024*1024) ) return FALSE;

		// dwLen ڸ ٲ ڱ̸ ְ
		*(&(*(DWORD*)pMain)+4) = (DWORD)nDestLen;

		// i  
		int i=1;
		sLen = (DWORD)nDestLen;

/*		//  
		while(sLen>=0x10){
			i++;
			sLen-=0x10;
		}
		i=(i*0x10)-0x1;
*/
		// ٸ 
		i=(sLen/0x10+1) * 0x10 - 1;

		//  i  ְ
		*(&(*(DWORD*)pMain)+5) = (DWORD)i;
		
		sLen = (DWORD)nDestLen;
		if(sLen >= 0x10){
			//  ڿ

			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: ANSI long\n"));

			//   
			// ZeroMemory(pMain, sizeof(DWORD) * 4);

			//  
			if (m_bMatchSize)	//  
			{
				size_t len = 0;
				while(len<nDestLen && len<nSrcLen)
				{
					size_t addval = 1;
					if( (BYTE)0x80 <= (BYTE)szSrc[len] ) addval = 2;

					if( len + addval > nDestLen ) break;

					len += addval;
				}

				memcpy(szDest, szSrc, (len+1));
				while(len<nDestLen)
				{
					szDest[len] = ' ';
					len++;
				}				

			}
			else if (m_bIgnoreBufLen)	// ۱ 
			{
				if (bWasLongMode)	//  ϴ ۰ ִ
				{
					lstrcpyA(szDest, szSrc);
				}
				else	//  ª ڿ ( )
				{
					//  
					*(CHAR **)pMain = szSrc;
				}
			}
			else	// ⺻ 
			{
				//  
				*(CHAR **)pMain = szSrc;
			}
		}
		else
		{
			NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: ANSI short\n"));
			// ª ڿ

			//   
			ZeroMemory(pMain, sizeof(DWORD) * 4);

			//  
			if (m_bMatchSize)	//  
			{
				size_t len = 0;
				while(len<nDestLen && len<nSrcLen)
				{
					size_t addval = 1;
					if( (BYTE)0x80 <= (BYTE)szSrc[len] ) addval = 2;

					if( len + addval > nDestLen ) break;

					len += addval;
				}

				memcpy(szDest, szSrc, (len+1));
				while(len<nDestLen)
				{
					szDest[len] = ' ';
					len++;
				}				

			}
			else	// ۱  & ⺻  
			{
				// ڿ 
				lstrcpyA((CHAR *)pMain, szSrc);
			}
		}
	}
	NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplySmartString: success\n"));
	return TRUE;
}

//////////////////////////////////////////////////////////////////////////
// ڿ ̸  ڿ ̷ մϴ. (̵)
//
BOOL CTransCommandSMSTR::ChangeLength(void *pOrigBasePtr, CTransScriptParser *pParser, void *pNewBasePtr)
{
	return CTransCommand::ChangeLength(m_pArgText, pParser, pNewBasePtr);
}

//////////////////////////////////////////////////////////////////////////
//   ڿ  α׷ մϴ. (̵)
//
BOOL CTransCommandSMSTR::ApplyTranslatedText(void *pArgText, PREGISTER_ENTRY pRegisters, CTransScriptParser *pParser, BOOL bIsDuplicated)
{
	if (bIsDuplicated)
	{
		if (m_bUnicode)
		{
			if (*(WCHAR *)m_pTransTextBuf == L'\0')
				return FALSE;
		}
		else
		{
			if (*(char *)m_pTransTextBuf == '\0')
				return FALSE;
		}
		//  ۿ   ״ Ѵ.
	}

	NOTIFY_DEBUG_MESSAGE(_T("SMSTR: ApplyTranslatedText: called\n"));

	return ApplySmartString(pArgText, m_pTransTextBuf);
	
}