#pragma once

typedef BOOL (__stdcall * PROC_ExtTextOutW)(HDC hdc, int X, int Y, UINT fuOptions, CONST RECT* lprc, LPCWSTR lpString, UINT cbCount, CONST INT* lpDx);
typedef BOOL (__stdcall * PROC_SetMenu)(HWND hWnd, HMENU hMenu);


class CWin32UIMgr
{
private:
	static CWin32UIMgr* _Inst;
	HWND	m_hWnd;
	HMENU	m_hOldMenu;
	BOOL	m_bTitleTrans;
	BOOL	m_bMenuTrans;
	PROC_ExtTextOutW m_pfnOrigExtTextOutW;
	PROC_SetMenu m_pfnOrigSetMenu;
	CString m_strOldTitle;
	CString m_strNewTitle;
	CStringArray m_arrKorItem;
	CStringArray m_arrJpnItem;
	DWORD	m_dwPID;

	CString TranslateUnicodeText(LPCWSTR cwszText, UINT nCP=932);
	int FindString(CStringArray& arr, LPCTSTR strToFind);
	void ScanMenuString(HMENU hMenu);
	void ChangeMenuRecursive(HMENU hMenu, CStringArray& arrSrc, CStringArray& arrTar);
	HMENU CreateMenuFromMenu(HMENU hOldMenu);		//  Լ
	BOOL FindGameWindow();
	void GetCurWindowTitle();


	static BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam);

	static BOOL __stdcall NewExtTextOutW(
		HDC hdc,          // handle to DC
		int X,            // x-coordinate of reference point
		int Y,            // y-coordinate of reference point
		UINT fuOptions,   // text-output options
		CONST RECT* lprc, // optional dimensions
		LPCWSTR lpString, // string
		UINT cbCount,     // number of characters in string
		CONST INT* lpDx   // array of spacing values
		);

	static BOOL __stdcall NewSetMenu(          
		HWND hWnd,
		HMENU hMenu
		);


public:
	CWin32UIMgr(void);
	~CWin32UIMgr(void);

	BOOL Init();
	void Close();

	void Invalidate();

	BOOL TransMenu();
	BOOL RestoreMenu();

	BOOL TransTitle();
	BOOL SetTitle(LPCTSTR szNewTitle);
	BOOL RestoreTitle();

};
